Subject: bug#48111: tilde in Go package names (eg. sourcehut hosted packages)

From: Leo Prikler <[email-masked]>
Date: Fri, 30 Apr 2021 11:53:40 +0200

Am Donnerstag, den 29.04.2021, 19:54 +0200 schrieb raingloom:
> Trying to import kineto and getting this error when building it:
> 
> guix build: error: invalid character `~' in name
> `go-git-sr-ht-~sircmpwn-kineto-0.0.0-20210225135222-edd4fe31f16f-
> checkout.drv'
> 
> I know the names are significant in go-build-system so I'm not sure
> how
> to work around the issue without breaking anything.
The way Go works, I would hazard a guess, that 
  module git.sr.ht/~sircmpwn/kineto
and 
  module git.sr.ht/sircmpwn/kineto
name two different modules.  However, as the latter can't exist since
sr.ht prefixes user names with ~, I think a name transformation, that
maps the former to the latter should be safe.  On the other hand, since
this just affects store file names, we might instead want to map "~" to
"-" in the general case of it appearing anywhere.  WDYT? 

Regards,
Leo